package sample;

import java.io.*;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

/**
 * Created by Patrick on 03.04.2016.
 */
public class FileHandling {
    public static String readFile(File file){
        String content = null;
        FileReader reader = null;
        try {
            reader = new FileReader(file);
            char[] chars = new char[(int) file.length()];
            reader.read(chars);
            content = new String(chars);
            reader.close();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if(reader !=null){
                try{reader.close();}catch(IOException e){}
            }
        }
        return content;
    }
    public static String readFileSec(File file) throws IOException {
        String content = null;
        FileReader reader = null;
        reader = new FileReader(file);
        char[] chars = new char[(int) file.length()];
        reader.read(chars);
        content = new String(chars);
        reader.close();
        if(reader !=null)
            reader.close();
        return content;
    }
    public static ArrayList<String> readFileToArray(File file){
        return readFileToArray(file,"");
    }
    //"UTF8"
    public static ArrayList<String> readFileToArray(File file,String type){
        ArrayList<String> lines=new ArrayList<>();
        if(type.equals("")){
            try (BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file)))) {
                String line="";
                    do{
                        try {
                            line = br.readLine();
                            if(line != null)
                                lines.add(line);
                        }catch(OutOfMemoryError e){System.out.println("Line to long: "+lines.size()+1);e.printStackTrace();}
                    }while (line!=null);
            }catch(FileNotFoundException e){}catch(IOException e){}}
        else{
            try (BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file), type))) {
                String line="";
                do{
                    try {
                        line = br.readLine();
                        if(line != null)
                            lines.add(line);
                    }catch(OutOfMemoryError e){System.out.println("Line to long: "+lines.size()+1);e.printStackTrace();}
                }while (line!=null);
            }catch(FileNotFoundException e){}catch(IOException e){}}
        return lines;
    }
    public static void writeFile(File file,String sData){
        file.getParentFile().mkdirs();
        try {
            Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file), "utf-8"));
            writer.write(sData);
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
            //NOTHING WRITTEN
        }
    }
    public static boolean unzip(File source){
        return unzip(source,new File(Main.workingDir+Main.sep+source.getName().substring(0,source.getName().lastIndexOf("."))));
    }
    public static boolean unzip(File source,File target){
        try
        {
            int BUFFER = 2048;
            File file = source;
            ZipFile zip = new ZipFile(file);
            String newPath = target.getAbsolutePath();
            new File(newPath).mkdir();
            Enumeration zipFileEntries = zip.entries();
            while (zipFileEntries.hasMoreElements())
            {
                ZipEntry entry = (ZipEntry) zipFileEntries.nextElement();
                String currentEntry = entry.getName();
                File destFile = new File(newPath, currentEntry);
                File destinationParent = destFile.getParentFile();
                destinationParent.mkdirs();
                if (!entry.isDirectory())
                {
                    BufferedInputStream is = new BufferedInputStream(zip
                            .getInputStream(entry));
                    int currentByte;
                    byte data[] = new byte[BUFFER];
                    FileOutputStream fos = new FileOutputStream(destFile);
                    BufferedOutputStream dest = new BufferedOutputStream(fos,
                            BUFFER);
                    while ((currentByte = is.read(data, 0, BUFFER)) != -1) {
                        dest.write(data, 0, currentByte);
                    }
                    dest.flush();
                    dest.close();
                    is.close();
                }
            }
        }
        catch (Exception e)
        {return false;}
        return true;
    }

}
